<?php

/**
 * Return a serv_duree from an index
 *
 * @param   int     $index      Index of a serv_duree
 * @return  string              null on error, value of the index on success
 */
function getServDureeFromIndex($index)
{
    global $db;

    $extrafield = new ExtraFields($db);

    $extrafield->fetch_name_optionals_label('contratdet');

    foreach ($extrafield->attribute_label as $key => $val)
    {

        if ($key == 'serv_duree')
            return $extrafield->attribute_param[$key]['options'][$index];
    }
    return null;
}

/**
 *      Update all serv_date_end field of lines given in parameter
 *
 *      @param      array       $lines      Lines to update
 *      @return     void
 */
function modifyDateEnd($lines)
{
    global $db;

    foreach ($lines as $key => $line)
    {
        $date = date_create($line['serv_date_start']);
        $duration = getServDureeFromIndex($line['serv_duree']);

        if (is_numeric($duration) && $line['serv_date_start'] != '0000-00-00') {
            //$old = clone $date;
            //echo $line['rowid'] . ': ' . $old->format('Y-m-d') . ' for ' . $duration . ' month => ' . $date->format('Y-m-d') . '<br/>';
            $date->modify('+' . $duration . ' month');
            $sql = 'UPDATE llx_contratdet_extrafields SET serv_date_end = "' . $date->format('Y-m-d H:i:s') . '" WHERE llx_contratdet_extrafields.rowid = ' . $line['rowid'];
            $db->query($sql);
        }
    }
}

/**
 *      Get all lines without serv_date_end attribute
 *
 *      @return     array
 */
function getIdWithoutDateEnd()
{
    global $db;
    $sql = 'SELECT * FROM llx_contratdet_extrafields as cd WHERE cd.serv_date_end IS NULL';

    $resql = $db->query($sql);

    foreach($resql as $key => $row)
    {
        $lines[] = $row;
    }
    return $lines;
}

/**
 *      Set NULL to all serv_date_end field of each lines on Db and redirect
 *
 *      @return     void
 */
function cleanDateEnd()
{
    global $db;
    $sql = 'SELECT * FROM llx_contratdet_extrafields as cd';

    $resql = $db->query($sql);

    foreach($resql as $key => $row)
    {
        $sql = 'UPDATE llx_contratdet_extrafields SET serv_date_end = NULL WHERE llx_contratdet_extrafields.rowid = ' . $row['rowid'];
        $db->query($sql);
    }
    header("Location: ".$_SERVER['PHP_SELF']);
}

/**
 *      Populate the serv_date_end extrafields of contratdet on Db and redirect
 *
 *      @return     void
 */
function populateDb()
{
    $lines = getIdWithoutDateEnd();
    modifyDateEnd($lines);
    header("Location: ".$_SERVER['PHP_SELF']);
}